Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ComparisonType.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ComparisonType.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ComparisonType.cs	(revision 16171)
@@ -0,0 +1,31 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data {
+  public enum ComparisonType {
+    Less,
+    LessOrEqual,
+    Equal,
+    GreaterOrEqual,
+    Greater,
+    NotEqual
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DateTimeValue.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DateTimeValue.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DateTimeValue.cs	(revision 16171)
@@ -0,0 +1,86 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("DateTimeValue", "Represents a date and time value.")]
+  [StorableClass]
+  public class DateTimeValue : ValueTypeValue<DateTime>, IComparable, IStringConvertibleValue {
+    [StorableConstructor]
+    protected DateTimeValue(bool deserializing) : base(deserializing) { }
+    protected DateTimeValue(DateTimeValue original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public DateTimeValue() : base() { }
+    public DateTimeValue(DateTime value) : base(value) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DateTimeValue(this, cloner);
+    }
+
+    public override string ToString() {
+      return Value.ToString("o");  // round-trip format
+    }
+
+    public virtual int CompareTo(object obj) {
+      DateTimeValue other = obj as DateTimeValue;
+      if (other != null)
+        return Value.CompareTo(other.Value);
+      else
+        return Value.CompareTo(obj);
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      DateTime val;
+      bool valid = DateTime.TryParse(value, out val);
+      errorMessage = valid ? string.Empty : "Invalid Value (values must be formatted according to the current culture settings)";
+      return valid;
+    }
+    protected virtual string GetValue() {
+      return Value.ToString("o");  // round-trip format
+    }
+    protected virtual bool SetValue(string value) {
+      DateTime val;
+      if (DateTime.TryParse(value, out val)) {
+        Value = val;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleArray.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 16171)
@@ -0,0 +1,70 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("DoubleArray", "Represents an array of double values.")]
+  [StorableClass]
+  public class DoubleArray : StringConvertibleArray<double> {
+    [StorableConstructor]
+    protected DoubleArray(bool deserializing) : base(deserializing) { }
+    protected DoubleArray(DoubleArray original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public DoubleArray() : base() { }
+    public DoubleArray(int length) : base(length) { }
+    public DoubleArray(double[] elements) : base(elements) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DoubleArray(this, cloner);
+    }
+
+    protected override bool Validate(string value, out string errorMessage) {
+      double val;
+      bool valid = double.TryParse(value, out val);
+      errorMessage = string.Empty;
+      if (!valid) {
+        StringBuilder sb = new StringBuilder();
+        sb.Append("Invalid Value (Valid Value Format: \"");
+        sb.Append(FormatPatterns.GetDoubleFormatPattern());
+        sb.Append("\")");
+        errorMessage = sb.ToString();
+      }
+      return valid;
+    }
+    protected override string GetValue(int index) {
+      return this[index].ToString("r");
+    }
+    protected override bool SetValue(string value, int index) {
+      double val;
+      if (double.TryParse(value, out val)) {
+        this[index] = val;
+        return true;
+      } else {
+        return false;
+      }
+    }
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleMatrix.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 16171)
@@ -0,0 +1,95 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("DoubleMatrix", "Represents a matrix of double values.")]
+  [StorableClass]
+  public class DoubleMatrix : ValueTypeMatrix<double>, IStringConvertibleMatrix {
+    [StorableConstructor]
+    protected DoubleMatrix(bool deserializing) : base(deserializing) { }
+    protected DoubleMatrix(DoubleMatrix original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public DoubleMatrix() : base() { }
+    public DoubleMatrix(int rows, int columns) : base(rows, columns) { }
+    public DoubleMatrix(int rows, int columns, IEnumerable<string> columnNames) : base(rows, columns, columnNames) { }
+    public DoubleMatrix(int rows, int columns, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(rows, columns, columnNames, rowNames) { }
+    public DoubleMatrix(double[,] elements) : base(elements) { }
+    public DoubleMatrix(double[,] elements, IEnumerable<string> columnNames) : base(elements, columnNames) { }
+    public DoubleMatrix(double[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(elements, columnNames, rowNames) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DoubleMatrix(this, cloner);
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      double val;
+      bool valid = double.TryParse(value, out val);
+      errorMessage = string.Empty;
+      if (!valid) {
+        StringBuilder sb = new StringBuilder();
+        sb.Append("Invalid Value (Valid Value Format: \"");
+        sb.Append(FormatPatterns.GetDoubleFormatPattern());
+        sb.Append("\")");
+        errorMessage = sb.ToString();
+      }
+      return valid;
+    }
+    protected virtual string GetValue(int rowIndex, int columIndex) {
+      return this[rowIndex, columIndex].ToString("r");
+    }
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
+      double val;
+      if (double.TryParse(value, out val)) {
+        this[rowIndex, columnIndex] = val;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    #region IStringConvertibleMatrix Members
+    int IStringConvertibleMatrix.Rows {
+      get { return Rows; }
+      set { Rows = value; }
+    }
+    int IStringConvertibleMatrix.Columns {
+      get { return Columns; }
+      set { Columns = value; }
+    }
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+      return GetValue(rowIndex, columIndex);
+    }
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      return SetValue(value, rowIndex, columnIndex);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleRange.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleRange.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleRange.cs	(revision 16171)
@@ -0,0 +1,68 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [StorableClass]
+  [Item("DoubleRange", "Represents a range of values betweent start and end.")]
+  public class DoubleRange : StringConvertibleValueTuple<DoubleValue, DoubleValue> {
+
+    public double Start {
+      get { return Item1.Value; }
+      set { Item1.Value = value; }
+    }
+    public double End {
+      get { return Item2.Value; }
+      set { Item2.Value = value; }
+    }
+    public double Size {
+      get { return End - Start; }
+    }
+
+    [StorableConstructor]
+    protected DoubleRange(bool deserializing) : base(deserializing) { }
+    protected DoubleRange(DoubleRange original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DoubleRange(this, cloner);
+    }
+
+    public DoubleRange() : base(new DoubleValue(), new DoubleValue()) { }
+    public DoubleRange(DoubleValue start, DoubleValue end) : base(start, end) { }
+    public DoubleRange(double start, double end) : base(new DoubleValue(start), new DoubleValue(end)) { }
+
+    public override string ToString() {
+      return string.Format("Start: {0:r}, End: {1:r}", Start, End);
+    }
+
+    public override StringConvertibleValueTuple<DoubleValue, DoubleValue> AsReadOnly() {
+      var readOnly = new DoubleRange();
+      readOnly.values = Tuple.Create<DoubleValue, DoubleValue>((DoubleValue)Item1.AsReadOnly(), (DoubleValue)Item2.AsReadOnly());
+      readOnly.readOnly = true;
+      return readOnly;
+    }
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleValue.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 16171)
@@ -0,0 +1,99 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("DoubleValue", "Represents a double value.")]
+  [StorableClass]
+  public class DoubleValue : ValueTypeValue<double>, IComparable, IStringConvertibleValue {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
+    }
+
+    [StorableConstructor]
+    protected DoubleValue(bool deserializing) : base(deserializing) { }
+    protected DoubleValue(DoubleValue original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public DoubleValue() : base() { }
+    public DoubleValue(double value) : base(value) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DoubleValue(this, cloner);
+    }
+
+    public override string ToString() {
+      return Value.ToString("r");  // round-trip format
+    }
+
+    public virtual int CompareTo(object obj) {
+      DoubleValue other = obj as DoubleValue;
+      if (other != null)
+        return Value.CompareTo(other.Value);
+      else
+        return Value.CompareTo(obj);
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      double val;
+      bool valid = double.TryParse(value, out val);
+      errorMessage = string.Empty;
+      if (!valid) {
+        StringBuilder sb = new StringBuilder();
+        sb.Append("Invalid Value (Valid Value Format: \"");
+        sb.Append(FormatPatterns.GetDoubleFormatPattern());
+        sb.Append("\")");
+        errorMessage = sb.ToString();
+      }
+      return valid;
+    }
+    protected virtual string GetValue() {
+      return Value.ToString("r");  // round-trip format
+    }
+    protected virtual bool SetValue(string value) {
+      double val;
+      if (double.TryParse(value, out val)) {
+        Value = val;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/EnumValue.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/EnumValue.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/EnumValue.cs	(revision 16171)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("EnumValue", "An abstract base class for representing values of enum types.")]
+  [StorableClass]
+  public sealed class EnumValue<T> : ValueTypeValue<T>, IComparable<EnumValue<T>> where T : struct, IComparable {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Enum; }
+    }
+
+    static EnumValue() {
+      if (!typeof(T).IsEnum)
+        throw new InvalidOperationException("Generic type " + typeof(T).Name + " is not an enum.");
+    }
+
+    public EnumValue() {
+      this.value = default(T);
+      this.readOnly = false;
+    }
+    public EnumValue(T value) {
+      this.value = value;
+      this.readOnly = false;
+    }
+
+    [StorableConstructor]
+    private EnumValue(bool deserializing) : base(deserializing) { }
+    private EnumValue(EnumValue<T> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EnumValue<T>(this, cloner);
+    }
+
+    public int CompareTo(EnumValue<T> other) {
+      return Value.CompareTo(other.Value);
+    }
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/FormatPatterns.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/FormatPatterns.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/FormatPatterns.cs	(revision 16171)
@@ -0,0 +1,56 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Globalization;
+using System.Text;
+
+namespace HeuristicLab.Data {
+  public static class FormatPatterns {
+    public static string GetBoolFormatPattern() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append(bool.TrueString).Append(" | ").Append(bool.FalseString);
+      return sb.ToString();
+    }
+    public static string GetDoubleFormatPattern() {
+      StringBuilder sb = new StringBuilder();
+      NumberFormatInfo nf = CultureInfo.CurrentCulture.NumberFormat;
+      sb.Append(nf.PositiveInfinitySymbol).Append(" | ");
+      sb.Append(nf.NegativeInfinitySymbol).Append(" | ");
+      sb.Append(nf.NaNSymbol).Append(" | ");
+      sb.Append("[").Append(nf.PositiveSign).Append(" | ").Append(nf.NegativeSign).Append("]");
+      sb.Append("digits[").Append(nf.NumberDecimalSeparator).Append("[digits]]");
+      sb.Append("[(e | E)");
+      sb.Append("[").Append(nf.PositiveSign).Append(" | ").Append(nf.NegativeSign).Append("]");
+      sb.Append("digits]");
+      return sb.ToString();
+    }
+    public static string GetIntFormatPattern() {
+      StringBuilder sb = new StringBuilder();
+      NumberFormatInfo nf = CultureInfo.CurrentCulture.NumberFormat;
+      sb.Append("[").Append(nf.PositiveSign).Append(" | ").Append(nf.NegativeSign).Append("]");
+      sb.Append("digits");
+      return sb.ToString();
+    }
+    public static string GetTimeSpanFormatPattern() {
+      return "[-](d | d.hh:mm[:ss[.ff]] | hh:mm[:ss[.ff]])";
+    }
+  }
+}
